/*	POSTIT -- Get the FORM parameters.
 *	Kurt J. Lanza (kjl@infor.com)
 *	21 March 1994
 *
 *	Derived from the "post-query" program by robm@ncsa.uiuc.edu --
 *		major credit to him.
 *
 *	This variant reads the "name=value" pairs from the POST method
 *		and writes lines of the form "name value". Thus this
 *		command may be used inside a Bourne shell "while" loop.
 *		Its intent is to provide arguments to the cgi-script.
 *	Why not just put them in the environment? I don't know -- just a
 *		guess that that approach might not be quite so general.
 */


#include <stdio.h>
#include <stdlib.h>

#define MAX_ENTRIES 10000

typedef struct {
    char *name;
    char *val;
} entry;

char *makeword(char *line, char stop);
char *fmakeword(FILE *f, char stop, int *len);
char x2c(char *what);
void unescape_url(char *url);
void plustospace(char *str);


main(int argc, char *argv[]) {
    entry entries[MAX_ENTRIES];
    register int x,m=0;
    int cl;

    if(strcmp(getenv("REQUEST_METHOD"),"POST")) exit(1);
    if(strcmp(getenv("CONTENT_TYPE"),"application/x-www-form-urlencoded")) exit(1);
    cl = atoi(getenv("CONTENT_LENGTH"));

    for(x=0;cl>0 && (!feof(stdin));x++) {
        m=x;
        entries[x].val = fmakeword(stdin,'&',&cl);
        plustospace(entries[x].val);
        unescape_url(entries[x].val);
        entries[x].name = makeword(entries[x].val,'=');
    }

    for(x=0; x <= m; x++)
        printf("%s %s%\n",entries[x].name, entries[x].val);
}
